#define _SVID_SOURCE
#define _GNU_SOURCE
#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <errno.h>
#include <signal.h>
#include <time.h>
#include <string.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include "main.h"



void gestionaire_signaux(int num_signal)
{
	if(num_signal == SIGQUIT || num_signal == SIGINT)
	{
		exit(0);
	}
}
void fils(int fd, MessageReseau_t *message)
{
  while(1)
  {
    receiveMessage(fd,message);
    
  }
  exit(0);
  
}



int main()
{
  srand(time(NULL)+getpid());
    
    
    struct sigaction ordre;
    sigemptyset(&(ordre.sa_mask));
    
    ordre.sa_handler = gestionaire_signaux;
    ordre.sa_flags = 0;
    
    sigaction(SIGQUIT,&ordre,NULL);
    sigaction(SIGINT,&ordre,NULL);
    
    
    
    struct sockaddr_in adresseServeur ;
    memset(&adresseServeur,0,sizeof(struct sockaddr_in));
    adresseServeur.sin_family = AF_INET; 
  
    
    int socket_data = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);

    int port_data_switch;
    char IP_Dest[17];
    
    MessageReseau_t message;
    memset(&message,0,sizeof(MessageReseau_t));
    message.IPdest.sin_family = AF_INET;
    
    int port_conf_switch;
    int port_dest;
    int reponse = 0;
    int pid_fils;
    struct sockaddr_in adresse_dest ;
    struct sockaddr_in adresse_conf_switch ;
    while(reponse != -1)
  {
    printf("Que voulez vous faire ?\n");
    printf("1 - Initialise connection switch\n");
    printf("2 - Send Message\n");
    printf("3 - setVlan\n");
    printf("4 - initialize connection inter switch\n");
    printf("-1 - Quitter\n");
    scanf("%d",&reponse);
    
    switch(reponse)
    {
      case -1:
	close(socket_data);
	kill(pid_fils,SIGQUIT);
	exit(0);
	break;
      case 1:
	///////////////RECUPERATION DES INFO DU SWITCH
	printf("Veuilliez rentrer l'adresse IP du switch :\n");
	scanf("%16s",IP_Dest);
	printf("Veuilliez rentrer le port de config du switch :\n");
	scanf("%d",&port_conf_switch);
	////INTITIALISATION DU PORT
	
	adresse_conf_switch.sin_port = htons(port_conf_switch);
	inet_pton(AF_INET ,IP_Dest,&adresse_conf_switch.sin_addr);
	
	
	port_data_switch = initializeconnectionswitch(adresse_conf_switch);
	printf("port data: %d\n",port_data_switch);
	
	adresseServeur.sin_port = htons(port_data_switch);
	inet_pton(AF_INET ,IP_Dest,&adresseServeur.sin_addr);
	sleep(1);
	if(connect(socket_data,(struct sockaddr*)&adresseServeur,sizeof(struct sockaddr_in)) == -1)
	{
	  fprintf(stderr, "Erreur connect : %s\n",strerror(errno));
	}
	if((pid_fils = fork()) == 0)
	{
	  fils(socket_data, &message);
	}
	
	break;
      case 2:
	// on definit l'IP de destination // l'adresse IP source sera gérer par le switch
	printf("Veuilliez rentrer l'adresse IP du destinataire :\n");
	scanf("%16s",IP_Dest);
	printf("Veuilliez rentrer le port du destinataire :\n");
	scanf("%d",&port_dest);
	printf("Veuilliez rentrer le message :\n");
	scanf("%499s",message.message);
	
	message.IPdest.sin_port = htons(port_dest);
	inet_pton(AF_INET ,IP_Dest,&message.IPdest.sin_addr);
	
	write(socket_data,&message,sizeof(MessageReseau_t)); 
	memset(&message,0,sizeof(MessageReseau_t));
	message.IPdest.sin_family = AF_INET;
	
	break;
      
      case 3:
	
	break;
      case 4:
	printf("Veuilliez rentrer l'adresse IP du switch dest :\n");
	scanf("%16s",IP_Dest);
	printf("Veuilliez rentrer le port de config du switch :\n");
	scanf("%d",&port_conf_switch);
	
	////INTITIALISATION DU PORT
	
	adresse_dest.sin_port = htons(port_conf_switch);
	inet_pton(AF_INET ,IP_Dest,&adresse_dest.sin_addr);
	
	
	break;
      
    }

}
return 0;
}

/*Retourne le port sur lequel envoiyer les donner
 * 
 */
int initializeconnectionswitch(struct sockaddr_in localaddr)
{
    int port_config = socket(AF_INET, SOCK_DGRAM, IPPROTO_UDP);
    if(port_config == -1)
    {
	fprintf(stderr, "Erreur lors de la creation de la socket pour le port de config : %s\n",strerror(errno));
	exit(EXIT_FAILURE);
    }
    printf("INTITIALISATION de la conection\n");
    
    
    Commande_t ma_commande;
    ma_commande.ordre = creeport;

    // on envoie la commande pour cree un port au switch
    sendto(port_config, &ma_commande, sizeof(Commande_t), 0,(struct sockaddr *)&localaddr, sizeof(struct sockaddr_in));
    
    printf("Commande envoiyer\n");
    ReponseCommande_t var;
    
    if(recv(port_config, &var, sizeof(ReponseCommande_t), 0) == -1)
    {
      fprintf(stderr, "Erreur lors de la reception d'ordre pour le port de config : %s\n",strerror(errno));
      return -1;
    }
    close(port_config);
    
    return var.port;
      
    
}
void initializeconnectioninterswitch(struct sockaddr_in confswitch,struct sockaddr_in confswitchdistant)
{
    int port_config = socket(AF_INET, SOCK_DGRAM, IPPROTO_UDP);
    if(port_config == -1)
    {
	fprintf(stderr, "Erreur lors de la creation de la socket pour le port de config : %s\n",strerror(errno));
	exit(EXIT_FAILURE);
    }
    printf("INTITIALISATION de la conection\n");
    
    
    Commande_t ma_commande;
    ma_commande.ordre = ConnexionInterSwitch;
    ma_commande.IPdest = confswitchdistant;
    
    // on envoie la commande pour cree un port au switch
    sendto(port_config, &ma_commande, sizeof(Commande_t), 0,(struct sockaddr *)&confswitch, sizeof(struct sockaddr_in));
    
    printf("Commande envoiyer\n");
    ReponseCommande_t var;
    
    if(recv(port_config, &var, sizeof(ReponseCommande_t), 0) == -1)
    {
      fprintf(stderr, "Erreur lors de la reception d'ordre pour le port de config : %s\n",strerror(errno));
      return ;
    }
    close(port_config);
    
    return;
  
}
int receiveMessage(int socket,MessageReseau_t *message)
{
	read(socket,message,sizeof(MessageReseau_t)); 
	printf("Message recu  :%s\n",message->message);
	memset(message,0,sizeof(MessageReseau_t));
	message->IPdest.sin_family = AF_INET;
	return 0;
}

