#define _SVID_SOURCE
#define _GNU_SOURCE
#include <arpa/inet.h>
#include "fils.h"
void *memoire_partager = NULL;
int noPort;
void gestionaire_signaux_fils(int num_signal)
{
	if(num_signal == SIGQUIT || num_signal == SIGINT)
	{
		Port_t * Port = (Port_t * )(memoire_partager + sizeof(memoire_switch_t));
		Port[noPort].pid = 0;
		exit(1);
		
	}
	
}

void fils(int port,int tube,int casememoire,config_outil_IPC_t * confIPC,int vlan,int trunk,char* IP_Dest,int portdest)
{
  noPort = casememoire;
  struct sigaction ordre;
  sigemptyset(&(ordre.sa_mask));
  
  ordre.sa_handler = gestionaire_signaux_fils;
  ordre.sa_flags = 0;
  
  sigaction(SIGQUIT,&ordre,NULL);
  sigaction(SIGINT,&ordre,NULL);

  if((memoire_partager = shmat(confIPC->seg_memoire_id, NULL,0)) == (void *)-1)
  {
	  printf("Une erreur est survenue lors de l'attachement de la memoire partager sur le port %d \n",casememoire);
	  exit(EXIT_FAILURE);
  }
  
  // rend le tube de lecteure non bloquand 
  if (fcntl(tube, F_SETFL, O_NONBLOCK))
   {
      close(tube);
      return ;
   }
  
  int ma_socket = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
  if(ma_socket == -1)
  {
      fprintf(stderr, "Erreur lors de la creation de la socket pour le port %d : %s\n",casememoire,strerror(errno));
      exit(EXIT_FAILURE);
  }
  
  
  struct sockaddr_in localaddr ;
  memset(&localaddr,0,sizeof(struct sockaddr_in));
  
  Port_t * Port = (Port_t * )(memoire_partager + sizeof(memoire_switch_t));
  Port[noPort].pid = getpid();
  Port[noPort].vlan = vlan;
  Port[noPort].trunk = trunk;
  int connexionfd;
  
  localaddr.sin_family = AF_INET; 
  localaddr.sin_addr.s_addr = htonl(INADDR_ANY);
  localaddr.sin_port = htons(port);;
  
  if(portdest == 0) // si on est pas client de la creation de port
  {
  
    if(bind(ma_socket,(struct sockaddr*)&localaddr,sizeof(struct sockaddr_in)) == -1)
    {
      fprintf(stderr, "Erreur lors du Bind pour le port %d : %s\n",casememoire,strerror(errno));
      exit(EXIT_FAILURE);
    }
    
    if (listen(ma_socket,2) == -1)
    {
      fprintf(stderr, "Erreur lors de la mise en ecoute pour le port %d: %s\n",casememoire,strerror(errno));
      exit(EXIT_FAILURE);
    }
  

    struct sockaddr_in adresse_source;
    socklen_t adresse_length = sizeof(struct sockaddr_in) ;
    connexionfd=accept(ma_socket,(struct sockaddr*)&adresse_source,&adresse_length);
    close(ma_socket);
    Port[noPort].IPdest = adresse_source;
    
    
  }
  else
  { // si on doit se connecter
	struct sockaddr_in serveur_adresse;
	memset(&serveur_adresse,0,sizeof(struct sockaddr_in));
	
	serveur_adresse.sin_family = AF_INET;
	serveur_adresse.sin_port = htons(portdest);
	inet_pton(AF_INET ,IP_Dest,&serveur_adresse.sin_addr);
	
	sleep(1);
	if(connect(ma_socket,(struct sockaddr*)&serveur_adresse,sizeof(struct sockaddr_in)) == -1)
	{
	  fprintf(stderr, "Erreur connect inter switch client: %s\n",strerror(errno));
	}
	Port[noPort].IPdest = serveur_adresse;
	connexionfd = ma_socket;
	free(IP_Dest);
  }
  
  
  // transformation de la socket en NON BLOCK 
  fcntl(connexionfd, F_SETFL, fcntl(connexionfd, F_GETFL, 0) | O_NONBLOCK);
  
  
  while(1)
  {
    usleep(500000);
    receptionExterieur(connexionfd,casememoire,Port[noPort].IPdest,confIPC);
    receptionCommande(tube,casememoire);
    receptionAutrePort(connexionfd,casememoire,confIPC);
  }
  
  
  
  
}
void receptionCommande(int tube,int portnum)
{
	Port_t * Port = (Port_t * )(memoire_partager + sizeof(memoire_switch_t));
	Commande_t commande;

	if(read(tube,&commande,sizeof(Commande_t)) == -1)
	{
	  if(EAGAIN == errno)
	  {
	    return; 
	  }
	  fprintf(stderr, "Erreur lors de la reception dune commabde sur le port %d : %s\n",portnum,strerror(errno));
	  return;
	}
	if(commande.ordre == VLAN)
	{
		Port[portnum].vlan = commande.vlan;
	}

}
void receptionExterieur(int fd,int portnum,struct sockaddr_in adresse_source,config_outil_IPC_t * confIPC)
{
	MessageReseau_t message_reseau;
	int octet_lu = read(fd,&message_reseau, sizeof(MessageReseau_t));
	Port_t * Port = (Port_t * )(memoire_partager + sizeof(memoire_switch_t));
	if(octet_lu == -1 || octet_lu == 0)
  	{
	  if(octet_lu == 0)
	  {
	      printf("terminaison du port : le client c'est barer en vacanse\n");
	      close(fd);
	      Port[portnum].pid = 0;
	      exit(0);
	  }
	  if(EAGAIN == errno)
	  {
	    return; 
	  }
	  fprintf(stderr, "Erreur lors de la reception d'un message : %s\n",strerror(errno));
	  return;
  	}
	message_reseau.IPsrc = adresse_source;
	printf("message recu\n");
	envoiAutrePort(portnum ,message_reseau,confIPC);
	
}

void receptionAutrePort(int fd,int portno,config_outil_IPC_t * confIPC)
{
	MessageReseau_t message_reseau;
	Port_t * Port = (Port_t * )(memoire_partager + sizeof(memoire_switch_t));
	
	if(msgrcv(confIPC->file_message_id, &message_reseau,sizeof(MessageReseau_t)-sizeof(long),getpid(),IPC_NOWAIT) == -1)
 	{
	    if(errno == ENOMSG)
	    {
			return;
	    }
	    else
	    {
			fprintf(stderr, "Erreur lors de la reception d'un message reseau de la file de message sur le port %d.\n",portno);
	    }
  	}
  	
	// cest un port trunck je me pose paq de question jenvoi !
	// je verifier que le message est bien pour moi si oui j'envoie

	if(Port[portno].trunk == 1 || adresse_eguale( &(Port[portno].IPdest), &(message_reseau.IPdest)) == 1)
	{
		if(write(fd,&message_reseau, sizeof(MessageReseau_t)) == -1)
  		{
		  fprintf(stderr, "Erreur lors de l'envoie d'un message du port %d : %s\n",portno,strerror(errno));
		  return;
  		}
	} 
	
}
int adresse_eguale(const struct sockaddr_in *IP1, const struct sockaddr_in *IP2)
{
  if(IP1->sin_addr.s_addr == IP2->sin_addr.s_addr && IP1->sin_port == IP1->sin_port)
  {
      return 1;
  }
  return 0;
  
}
void envoiAutrePort(int portnum ,MessageReseau_t message_reseau,config_outil_IPC_t * confIPC)
{
	memoire_switch_t * memoire_switch = (memoire_switch_t *) memoire_partager;
	Port_t * Port = (Port_t * )(memoire_partager + sizeof(memoire_switch_t));
	
	// on tag le paquet que si c'est pas un port trunk ; 
	if(Port[portnum].trunk == 0)
	{
		message_reseau.vlan = Port[portnum].vlan;
	}
	
	int i;
	for(i = 0; i < memoire_switch->nbPort; i++)
	{
		if((adresse_eguale( &(Port[i].IPdest), &(message_reseau.IPdest)) == 1 && Port[i].vlan == message_reseau.vlan) || Port[i].trunk == 1 )
		{
			// on envoie le message au port concerner
			message_reseau.type = Port[i].pid;
			if(msgsnd(confIPC->file_message_id, &message_reseau,sizeof(MessageReseau_t)-sizeof(long),0) == -1)
  			{
      			fprintf(stderr, "Erreur lors de l'envoie du message dans la file IPC sur le port %d.\n",portnum);
  			}
		}
	}
}
